#include "dirfiledialog.h"

DirFileDialog::DirFileDialog(QWidget *parent) : QDialog(parent)
{
	dir.setFilter(QDir::AllDirs | QDir::Hidden | QDir::Files);
	dir.setSorting(QDir::DirsFirst);

	lw = new QListWidget();
	lw->setUniformItemSizes(true);
	lw->setSizePolicy(QSizePolicy::MinimumExpanding, QSizePolicy::MinimumExpanding);
	lw->setResizeMode(QListView::Adjust);
	lw->setWrapping(true);
	lw->setSpacing(1);

	gl = new QGridLayout();
	gl->addWidget(lw, 1, 0, 1, 4);
	setLayout(gl);

	setWindowTitle("Get NFSv4 ACL for file or directory ...");
//	setMinimumSize(500, 300);
	setSizePolicy(QSizePolicy::Expanding, QSizePolicy::Expanding);
	resize(530, 340);
}

int DirFileDialog::populateView()
{
	fil = dir.entryInfoList();

	for (int i = 0; i < fil.size(); i++) {
		fi = fil.at(i);
		new QListWidgetItem(iconForInfo(fi), fi.fileName(), lw);
	}
	updateGeometry();
}

QIcon DirFileDialog::iconForInfo(QFileInfo &info)
{
	/* XXX: need to expand icons for, e.g., symlinks, etc */
	if (info.isDir())
		return (QIcon(QString(":images/citi-icon.gif")));
	else
		return (QIcon(QString(":images/user.gif")));
}

int DirFileDialog::exec()
{
	populateView();
	return ((QDialog *)this)->exec();
}
